//--------------------------------------------------------
//  Forex Expert Advisor Generator version 2.03 EA
//--------------------------------------------------------

#property copyright "Copyright  2010, Forex EA Generator v2.03"
#property link      "http://www.forexgenerator.com/"
#include <stdlib.mqh>

// exported variables
extern int TrailingStop22 = 10;
extern int NewTakeProfit22 = 30;
extern double BuyLots16 = 0.1;
extern int BuyStoploss16 = 15;
extern int BuyTakeprofit16 = 20;
extern double SellLots17 = 0.1;
extern int SellStoploss17 = 15;
extern int SellTakeprofit17 = 20;


// local variables
double PipValue=1;    // this variable is here to support 5-digit brokers
bool Terminated = false;
int Count20 = 0;


int init()
{
    
    Comment("");    // clear the chart
}

// Expert start
int start()
{
    if (Bars < 10)
    {
        Comment("Not enough bars");
        return (0);
    }
    if (Terminated == true)
    {
        Comment("EA Terminated.");
        return (0);
    }
    
    OnEveryTick15();
    
}

void OnEveryTick15()
{
    if (true) PipValue = 10;
    PrintInfoToChart20();
    TrailingStop22();
    TechnicalAnalysis2x2();
    TechnicalAnalysis2x34();
    
}

void PrintInfoToChart20()
{
    string temp = "Some Text\nExecuted : " + Count20 + "\n"
    + "Spread: " + DoubleToStr(MarketInfo(Symbol(), MODE_SPREAD)/PipValue, 2)+ "\n"
    + "------------------------------------------------\n"
    + "ACCOUNT INFORMATION:\n"
    + "\n"
    + "Account Name:     " + AccountName()+ "\n"
    + "Account Leverage:     " + DoubleToStr(AccountLeverage(), 0)+ "\n"
    + "Account Balance:     " + DoubleToStr(AccountBalance(), 2)+ "\n"
    + "Account Equity:     " + DoubleToStr(AccountEquity(), 2)+ "\n"
    + "Free Margin:     " + DoubleToStr(AccountFreeMargin(), 2)+ "\n"
    + "Used Margin:     " + DoubleToStr(AccountMargin(), 2)+ "\n"
    + "------------------------------------------------\n";
    Comment(temp);
    Count20++;
    
}

void TrailingStop22()
{
    for (int i=OrdersTotal()-1; i >= 0; i--)
    if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES))
    {
        if (OrderSymbol() == Symbol() && OrderMagicNumber() == 1)
        {
            if (OrderType() == OP_BUY && Ask - OrderOpenPrice() > TrailingStop22*PipValue*Point)
            {
                if (OrderStopLoss() < Ask-(TrailingStop22+3)*PipValue*Point)
                OrderModify(OrderTicket(), OrderOpenPrice(), Ask-TrailingStop22*PipValue*Point, Ask+(NewTakeProfit22 + TrailingStop22)*PipValue*Point, OrderExpiration(), White);
            }
            if (OrderType() == OP_SELL && OrderOpenPrice() - Bid > TrailingStop22*PipValue*Point)
            {
                if (OrderStopLoss() > Bid+(TrailingStop22+3)*PipValue*Point)
                OrderModify(OrderTicket(), OrderOpenPrice(), Bid+TrailingStop22*PipValue*Point, Bid-(NewTakeProfit22 + TrailingStop22)*PipValue*Point, OrderExpiration(), White);
            }
        }
    }
    else
    Print("OrderSelect() error - ", ErrorDescription(GetLastError()));
    
}

void TechnicalAnalysis2x2()
{
    if ((iCustom(NULL, NULL, "ForexFreedomBarsNRP",1,5,15,30,30,2,2,2,2,1,0) == 4) && (iCustom(NULL, NULL, "ForexFreedomBarsNRP",1,5,15,30,30,2,2,2,2,3,0) == 3))
    {
        TechnicalAnalysis2x5();
        
    }
}

void TechnicalAnalysis2x5()
{
    if ((iCustom(NULL, NULL, "ForexFreedomBarsNRP",1,5,15,30,30,2,2,2,2,5,0) == 2) && (iCustom(NULL, NULL, "ForexFreedomBarsNRP",1,5,15,30,30,2,2,2,2,7,0) == 1))
    {
        TechnicalAnalysis2x26();
        
    }
}

void TechnicalAnalysis2x26()
{
    if ((iCustom(NULL, NULL, "ForexFreedomBarsNRP",1,5,15,30,30,2,2,2,2,1,1) == 4) && (iCustom(NULL, NULL, "ForexFreedomBarsNRP",1,5,15,30,30,2,2,2,2,3,1) == 3))
    {
        TechnicalAnalysis2x27();
        
    }
}

void TechnicalAnalysis2x27()
{
    if ((iCustom(NULL, NULL, "ForexFreedomBarsNRP",1,5,15,30,30,2,2,2,2,5,1) == 2) && (iCustom(NULL, NULL, "ForexFreedomBarsNRP",1,5,15,30,30,2,2,2,2,7,1) == 1))
    {
        CloseOrder24();
        
    }
}

void CloseOrder24()
{
    int orderstotal = OrdersTotal();
    int orders = 0;
    int ordticket[30][2];
    for (int i = 0; i < orderstotal; i++)
    {
        OrderSelect(i, SELECT_BY_POS, MODE_TRADES);
        if (OrderType() != OP_SELL || OrderSymbol() != Symbol() || OrderMagicNumber() != 1)
        {
            continue;
        }
        ordticket[orders][0] = OrderOpenTime();
        ordticket[orders][1] = OrderTicket();
        orders++;
    }
    if (orders > 1)
    {
        ArrayResize(ordticket,orders);
        ArraySort(ordticket);
    }
    for (i = 0; i < orders; i++)
    {
        if (OrderSelect(ordticket[i][1], SELECT_BY_TICKET) == true)
        {
            bool ret = OrderClose(OrderTicket(), OrderLots(), OrderClosePrice(), 4, Red);
            if (ret == false)
            Print("OrderClose() error - ", ErrorDescription(GetLastError()));
        }
    }
    TechnicalAnalysis10();
    
}

void TechnicalAnalysis10()
{
    if (iMACD(NULL, NULL,12,26,9,PRICE_CLOSE,MODE_MAIN,0) > 0)
    {
        IfOrderDoesNotExist19();
        
    }
}

void IfOrderDoesNotExist19()
{
    bool exists = false;
    for (int i=OrdersTotal()-1; i >= 0; i--)
    if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES))
    {
        if (OrderType() == OP_BUY && OrderSymbol() == Symbol() && OrderMagicNumber() == 1)
        {
            exists = true;
        }
    }
    else
    {
        Print("OrderSelect() error - ", ErrorDescription(GetLastError()));
    }
    
    if (exists == false)
    {
        BuyOrder16();
        
    }
}

void BuyOrder16()
{
    
    int ticket = OrderSend(Symbol(), OP_BUY, BuyLots16, Ask, 4, 0, 0, "My Buy", 1, 0, Blue);
    if (ticket > -1)
    {
        OrderSelect(ticket, SELECT_BY_TICKET);
        bool ret = OrderModify(OrderTicket(), OrderOpenPrice(), Ask - BuyStoploss16*PipValue*Point, Ask + BuyTakeprofit16*PipValue*Point, 0, Blue);
        if (ret == false)
        Print("OrderModify() error - ", ErrorDescription(GetLastError()));
            
    }
    else
    {
        Print("OrderSend() error - ", ErrorDescription(GetLastError()));
    }
}

void TechnicalAnalysis2x34()
{
    if ((iCustom(NULL, NULL, "ForexFreedomBarsNRP",1,5,15,30,30,2,2,2,2,0,0) == 4) && (iCustom(NULL, NULL, "ForexFreedomBarsNRP",1,5,15,30,30,2,2,2,2,2,0) == 3))
    {
        TechnicalAnalysis2x35();
        
    }
}

void TechnicalAnalysis2x35()
{
    if ((iCustom(NULL, NULL, "ForexFreedomBarsNRP",1,5,15,30,30,2,2,2,2,4,0) == 2) && (iCustom(NULL, NULL, "ForexFreedomBarsNRP",1,5,15,30,30,2,2,2,2,6,0) == 1))
    {
        TechnicalAnalysis2x28();
        
    }
}

void TechnicalAnalysis2x28()
{
    if ((iCustom(NULL, NULL, "ForexFreedomBarsNRP",1,5,15,30,30,2,2,2,2,0,1) == 4) && (iCustom(NULL, NULL, "ForexFreedomBarsNRP",1,5,15,30,30,2,2,2,2,2,1) == 3))
    {
        TechnicalAnalysis2x29();
        
    }
}

void TechnicalAnalysis2x29()
{
    if ((iCustom(NULL, NULL, "ForexFreedomBarsNRP",1,5,15,30,30,2,2,2,2,4,1) == 2) && (iCustom(NULL, NULL, "ForexFreedomBarsNRP",1,5,15,30,30,2,2,2,2,6,1) == 1))
    {
        CloseOrder23();
        
    }
}

void CloseOrder23()
{
    int orderstotal = OrdersTotal();
    int orders = 0;
    int ordticket[30][2];
    for (int i = 0; i < orderstotal; i++)
    {
        OrderSelect(i, SELECT_BY_POS, MODE_TRADES);
        if (OrderType() != OP_BUY || OrderSymbol() != Symbol() || OrderMagicNumber() != 1)
        {
            continue;
        }
        ordticket[orders][0] = OrderOpenTime();
        ordticket[orders][1] = OrderTicket();
        orders++;
    }
    if (orders > 1)
    {
        ArrayResize(ordticket,orders);
        ArraySort(ordticket);
    }
    for (i = 0; i < orders; i++)
    {
        if (OrderSelect(ordticket[i][1], SELECT_BY_TICKET) == true)
        {
            bool ret = OrderClose(OrderTicket(), OrderLots(), OrderClosePrice(), 4, Red);
            if (ret == false)
            Print("OrderClose() error - ", ErrorDescription(GetLastError()));
        }
    }
    TechnicalAnalysis12();
    
}

void TechnicalAnalysis12()
{
    if (iMACD(NULL, NULL,12,26,9,PRICE_CLOSE,MODE_MAIN,0) < 0)
    {
        IfOrderDoesNotExist18();
        
    }
}

void IfOrderDoesNotExist18()
{
    bool exists = false;
    for (int i=OrdersTotal()-1; i >= 0; i--)
    if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES))
    {
        if (OrderType() == OP_SELL && OrderSymbol() == Symbol() && OrderMagicNumber() == 1)
        {
            exists = true;
        }
    }
    else
    {
        Print("OrderSelect() error - ", ErrorDescription(GetLastError()));
    }
    
    if (exists == false)
    {
        SellOrder17();
        
    }
}

void SellOrder17()
{
    
    int ticket = OrderSend(Symbol(), OP_SELL, SellLots17, Bid, 4, 0, 0, "My Sell", 1, 0, Red);
    if (ticket > -1)
    {
        OrderSelect(ticket, SELECT_BY_TICKET);
        bool ret = OrderModify(OrderTicket(), OrderOpenPrice(), Bid + SellStoploss17*PipValue*Point, Bid - SellTakeprofit17*PipValue*Point, 0, Red);
        if (ret == false)
        Print("OrderModify() error - ", ErrorDescription(GetLastError()));
            
    }
    else
    {
        Print("OrderSend() error - ", ErrorDescription(GetLastError()));
    }
}



int deinit()
{
    
}

